package smash.appointment.parse;

import java.text.SimpleDateFormat;
import java.util.Calendar;

public class SqlExporter {

	private static final SimpleDateFormat DATE_FORMATTER = new SimpleDateFormat("yyyy-MM-dd");

	public SqlExporter() {
		super();
	}

	protected boolean isBefore(AppointmentEntry entry, Calendar minDate) {
		String entryDate = entry.getDay();
		String beforeDate = DATE_FORMATTER.format(minDate.getTime());
		if (entryDate.compareTo(beforeDate) < 0) {
			return true;
		} else {
			return false;
		}
	}

	protected String getStringVal(String arg) {
		if (arg == null) {
			return "null";
		} else if (arg.isEmpty()) {
			return "''";
		} else {
			return "'" + arg.replace("'", "''") + "'";
		}
	}

	protected String getIntVal(String diagnosisYear) {
		if (diagnosisYear == null || diagnosisYear.trim().isEmpty()) {
			return "0";
		} else {
			return diagnosisYear;
		}
	}

	protected String getDateVal(String arg) {
		if (arg == null) {
			return "null";
		} else if (arg.isEmpty()) {
			return "null";
		} else {
			return "'" + arg + "'";
		}
	}

}